﻿/**
 * rutor.org plugin for Movian Media Center
 *
 *  Copyright (C) 2015 lprot
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

(function(plugin) {
    var logo = plugin.path + "logo.png";

    var blue = '6699CC', orange = 'FFA500', red = 'EE0000', green = '66ff72';

    function colorStr(str, color) {
        return '<font color="' + color + '"> (' + str + ')</font>';
    }

    function coloredStr(str, color) {
        return '<font color="' + color + '">' + str + '</font>';
    }

    function setPageHeader(page, title) {
        if (page.metadata) {
            page.metadata.title = title;
            page.metadata.logo = logo;
        }
        page.type = "directory";
        page.contents = "items";
        page.loading = false;
    }

    var service = plugin.createService(plugin.getDescriptor().title, plugin.getDescriptor().id + ":start", "video", true, logo);

    var settings = plugin.createSettings(plugin.getDescriptor().title, logo, plugin.getDescriptor().synopsis);

    settings.createString('baseURL', "Base URL without '/' at the end.", 'https://hdrezka.download', function(v) {
        service.baseURL = v;
    });
    settings.createString("domain", "Домен", "hdrezka", function (v) {
        service.domain = v;
    });


    function list(page, doc) {
        // 1-date, 2-filelink, 3-infolink, 4-title, 5-(1)size, (2)seeds, (3)peers
		// 1-link 2-type 3-icon 4 - title
		var doc = doc.match(/ <h1 class="h1[\s\S]*?<\/html>/g);
        var re = /<a href="([\s\S]*?)" class="card-item">[\s\S]*?card-item-type[\s\S]*?">([\s\S]*?)<\/span><img src="([\s\S]*?)" alt="([\s\S]*?)"[\s\S]*?title="([\s\S]*?)"[\s\S]*?ci-param">([\s\S]*?)</g;
        var match = re.exec(doc);
        while (match) {
            
            var url = service.baseURL + match[1];
            
            page.appendItem(plugin.getDescriptor().id +':list:' + url+':'+escape(match[4])+' ('+escape(match[6])+')', "video", {
			title: new showtime.RichText(match[4]+ coloredStr(' (', orange) +coloredStr(match[6], orange)+coloredStr(')', orange)),
				//title: match[4]+ ' ('+match[6]+')', 
				icon: match[3]});
			//console.log(match[1]);
           	page.entries++;
            match = re.exec(doc);
        }
    }

    function search(page, doc) {
        // 1-date, 2-filelink, 3-infolink, 4-title, 5-(1)size, (2)seeds, (3)peers
		// 1-link 2-type 3-icon 4 - title
		//var doc = doc.match(/<body>[\s\S]*?<\/html>/g);
        //var re = /<a href="([\s\S]*?)" class="card-item">[\s\S]*?card-item-type[\s\S]*?">([\s\S]*?)<\/span><img src="([\s\S]*?)" alt="([\s\S]*?)"[\s\S]*?title="([\s\S]*?)"[\s\S]*?ci-param">([\s\S]*?)</g;
        var re = /<a href="([\s\S]*?)" class="sr-item">[\s\S]*?<div class="sr-cover"><img src="([\s\S]*?)" alt="([\s\S]*?)"[\s\S]*?<div class="sr-param">([\s\S]*?)</g;
        var match = re.exec(doc);

        while (match) { 
            var url = service.baseURL + match[1];
            //сonsole.log(url);
            page.appendItem(plugin.getDescriptor().id +':list:' + url+':'+escape(match[3])+' ('+escape(match[4])+')', "video", {
			title: new showtime.RichText(match[3]+ coloredStr(' (', orange) +coloredStr(match[4], orange)+ coloredStr(')', orange)),
				//title: match[4]+ ' ('+match[6]+')', 
				icon: match[2]});
			//console.log(match[1]);
           	page.entries++;
            match = re.exec(doc);
        }
    }


   
	function scraper(page, doc) {
        // 1-date, 2-filelink, 3-infolink, 4-title, 5-(1)size, (2)seeds, (3)peers
		//1-icon 2-title 3-type 4-date 5-engtitle 6 year 7-country 8-genre 9 description 
        var head= /<div class="si-cover">[\s\S]*?<img src="([\s\S]*?)"[\s\S]*?<h1 class="si-title">([\s\S]*?)<[\s\S]*?<div class="si-param">([\s\S]*?)<[\s\S]*?<div class="si-date">([\s\S]*?)<[\s\S]*?<li>([\s\S]*?)<[\s\S]*?<li>([\s\S]*?)<[\s\S]*?<li>([\s\S]*?)<[\s\S]*?<li>([\s\S]*?)<[\s\S]*?/g;
        //var head= /<div class="si-cover">[\s\S]*?<img src="([\s\S]*?)"[\s\S]*?<h1 class="si-title">([\s\S]*?)<[\s\S]*?<div class="si-param">([\s\S]*?)<[\s\S]*?<div class="si-date">([\s\S]*?)<[\s\S]*?<li>([\s\S]*?)<[\s\S]*?<li>([\s\S]*?)<[\s\S]*?<li>([\s\S]*?)<[\s\S]*?<li>([\s\S]*?)<[\s\S]*?dwn-list-none_collapser">([\s\S]*?)<[\s\S]*?<div class=\"dwn-links-list\">\n([\s\S]*?)\n/g;
		
        
		var docref=doc.match(/<div class=\"dwn-links-list\">\n([\s\S]*?)\n/g).toString();
        

		//1-link 2 - resolution
		fyefyedfy=/a href="([\s\S]*?)" class="dwn-links-item">([\s\S]*?)</g;
        
        
		//console.log('torref[1]='+torref[1]);
		
        var desc = /<div class="si-story">([\s\S]*?)<[\s\S]*?/;
        //var match2 = docref.exec(doc);
		var match1 = head.exec(doc);
		//console.log('docref: '+docref[1]);
		
        var torref = fyefyedfy.exec(docref);
        console.log('docref: '+torref[1]);
        
		while (torref) {
            
            var url = service.baseURL + torref[1];
            //var film = match1[9];
            //if (/Скачать через торрент/.test(film)) {
            //    film = "Фильм";
            //}
               
            page.appendItem('torrent:browse:' + url, "video", 
			{
			title: new showtime.RichText(coloredStr(match1[2], orange) + ' ('+torref[2]+')'),  
			description: new showtime.RichText(match1[8]),
			icon: match1[1]
			});
			
            page.entries++;
           torref = fyefyedfy.exec(docref);
        }
		
		
		
		var actors = /жиссер[\s\S]*?(?:ктеры|ролях)+[<>:\/b ]{2,7}[\s\S]*?\B[А-я][\s\S]*?<br \/>/;
		var actors1 = /([А-я \-\.]+(?: (([А-Я][а-я\-\.]*){1,3}(?:\(I*\))?)))/g;
		var match2 = actors.exec(doc);
		var error = false;
		try {var match3 = actors1.exec(match2);} catch(e){var error=true}
		var iconurl = /actor\/+([\d]+).jpg/;
		var kinopoisk = 'https://www.kinopoisk.ru/index.php?kp_query=';
		
		if (!error) try{{
		while (match3) {
            
            var url = '/search/0/0/010/2/' + encodeURI(match3[1]);
			var kinopage = showtime.httpReq(kinopoisk + (match3[1]));
           	page.appendItem(plugin.getDescriptor().id + ':category:' + url + ':' + encodeURI(match3[1]), "video", 
			{		
			title: new showtime.RichText(coloredStr(match3[1], orange)),
			icon: 'https://st.kp.yandex.net/images/sm_actor/' + iconurl.exec(kinopage)[1] + '.jpg'
			
			});
			
            page.entries++;
            match3 = actors1.exec(match2);
        }
		}} catch(e){popup.notify(e,5)}
		
		var re = /<tr class="[gai|tum]+"><td>([\s\S]*?)<\/td>[\s\S]*?href="([\s\S]*?)"[\s\S]*?<a href[\s\S]*?<a href="([\s\S]*?)">([\s\S]*?)<\/a>([\s\S]*?)<\/tr>/g;
        var match = re.exec(doc);
        while (match) {
            if (match[5].match(/alt="C"/)) {
                var end = match[5].match(/[\s\S]*?<td align="right">[\s\S]*?<td align="right">([\s\S]*?)<[\s\S]*?nbsp;([\s\S]*?)<\/span>[\s\S]*?nbsp;([\s\S]*?)<\/span>/);
                var comments = match[5].match(/[\s\S]*?<td align="right">([\s\S]*?)</)[1];
            } else
                var end = match[5].match(/[\s\S]*?<td align="right">([\s\S]*?)<[\s\S]*?nbsp;([\s\S]*?)<\/span>[\s\S]*?nbsp;([\s\S]*?)<\/span>/);
            var url = service.baseURL + match[3];
            if (match[3].match(/http:\/\//))
                url = match[3].match(/(\/download.*)/)[1];
            page.appendItem(plugin.getDescriptor().id +':list:' + url, "directory", {title: new showtime.RichText(coloredStr(match[1], orange) + ' ' +match[4] +  coloredStr(end[2], green) + '/'+coloredStr(end[3], red) +  colorStr(end[1], blue) +(comments ? colorStr(comments, orange) : ''))});
           	page.entries++;
            match = re.exec(doc);
        }
        
    }

		plugin.addURI(plugin.getDescriptor().id + ":random", function(page) {
	        setPageHeader(page, "Случайное кино");
        page.loading = true;
        var doc = showtime.httpReq('https://www.randommovie.ru/').toString();
		var re = /div class="col s12 m4"[\s\S]*?\(([\s\S]*?)\)[\s\S]*?white-text">([\s\S]*?)<[\s\S]*?<p>([\s\S]*?)<[\s\S]*?persons">([\s\S]*?)<p>([\s\S]*?)<\/p>/g;
		
        match = re.exec(doc);
        while (match!=null) {
            page.appendItem(plugin.getDescriptor().id + ':category:' + '/search/0/0/000/2/' + encodeURI(match[2]) + ':' + encodeURI('/search/0/0/010/2/' + encodeURI(match[2])), "video", 
			{		
			title: new showtime.RichText(coloredStr(match[2] + ', ' + match[3], orange)),
			icon: 'https://www.randommovie.ru' + match[1],
			description: match[5]
			
			});
            
           	
			
            page.entries++;
			match = re.exec(doc);
            //match3 = actors1.exec(match2);
        }
        page.loading = false;
    }); 
    
	plugin.addURI(plugin.getDescriptor().id + ":search:(.*)", function(page, name) {
        //setPageHeader(page, name);
        setPageHeader(page, "Результат поиска по запросу : " + name);
    page.loading = true;
    var url = "/ajax_search?q=";
    var fromPage = 1, tryToSearch = true;
//page.entries = 0;
    //var doc = showtime.httpReq(service.baseURL + url).toString();
     function loader() {
    var doc = showtime.httpReq(service.baseURL + url + encodeURIComponent(name), {headers: {'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/604.4.7 (KHTML, like Gecko) Version/11.0.2 Safari/604.4.7'}}).toString();
    
    //doc = doc.match(/<div class="cardlist[\s\S]*?<div/);
    console.log(url+encodeURIComponent(name));
    if (doc) {
        // 1-link 2-type 3-icon 4 - title
       var re = /<body>/g;
       var match = re.exec(doc);
       while (match) {

          //page.appendItem("", "separator", {title: new showtime.RichText(url)});
          search(page, match[1]);
           match = re.exec(doc);
       }
    }; {search(page, doc)};
     fromPage++;
    return false;
     }
     loader();
    page.asyncPaginator = loader;
    page.loading = false;
    });
	
	plugin.addURI(plugin.getDescriptor().id + ":category:(.*):(.*)", function(page, url, name) {
	        setPageHeader(page, name);
        page.loading = true;
		var fromPage = 1, tryToSearch = true;
    page.entries = 0;
        //var doc = showtime.httpReq(service.baseURL + url).toString();
		 function loader() {
		var doc = showtime.httpReq(service.baseURL + url+'/page/'+fromPage, {headers: {'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/604.4.7 (KHTML, like Gecko) Version/11.0.2 Safari/604.4.7'}}).toString();
		
        //doc = doc.match(/<div class="cardlist[\s\S]*?<div/);
		console.log(url);
        if (doc) {
			// 1-link 2-type 3-icon 4 - title
           var re = /<h1 class="h1__">([\s\S]*?)</g;
           var match = re.exec(doc);
           while (match) {
              //page.appendItem("", "separator", {title: new showtime.RichText(url)});
              list(page, match[1]);
			   match = re.exec(doc);
           }
        }; {list(page, doc)};
		 fromPage++;
        return true;
		 }
		 loader();
    page.paginator = loader;
        page.loading = false;
    }); 

    plugin.addURI(plugin.getDescriptor().id + ":list:(.*):(.*)", function(page, url, title) {
        setPageHeader(page, unescape(title));
        page.loading = true;
       // var doc = showtime.httpReq(url).toString();
		var doc = showtime.httpReq(url, {headers: {'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/604.4.7 (KHTML, like Gecko) Version/11.0.2 Safari/604.4.7'}}).toString();
        scraper(page, doc); 
        page.loading = false;
    });


	
	
	
plugin.addURI(plugin.getDescriptor().id + ":start", function (page) {
        
        var pages = [
                {
                    url: '',
                    name: 'Новое'
                },{
                    url: '/films',
                    name: 'Фильмы'
                },
                {
                    url: '/series',
                    name: 'Сериалы'
                },
                {
                    url: "/cartoons",
                    name: "Мультфильмы"
                },                
                {
                    url: '/animation',
                    name: 'Аниме'
                }
				
				
            ],
            i, length = pages.length;
        setPageHeader(page, plugin.getDescriptor().synopsis);
        page.appendItem(plugin.getDescriptor().id  + ":search:", 'search', {
            title: 'Поиск на ' + service.domain
        });
        page.appendItem("", "separator", {
            title: "Разделы" 
        });
        for (i = 0; i < length; i++)
		{
            
			page.appendItem(plugin.getDescriptor().id + ":category:" + pages[i].url + ':' + pages[i].name, "directory", { title: pages[i].name});
			
        
		}
		
		//var doc = showtime.httpReq('https://www.myip.com', {headers: {'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/604.4.7 (KHTML, like Gecko) Version/11.0.2 Safari/604.4.7'}}).toString();	
		//var re=/id="ip">([\s\S]*?)<[\s\S]*?Country: <\/div><div class="info_2">([\s\S]*?)</;
		//var match=re.exec(doc);
		// page.appendItem("", "separator", {title: new showtime.RichText('Ip: '+match[1])+', Country: '+match[2]});
    });
	
    plugin.addSearcher(plugin.getDescriptor().id, logo, function(page, query) {
	page.entries = 0;
	var fromPage = 0, tryToSearch = true;
	
	function loader() {
            if (!tryToSearch) return false;
            page.loading = true;
        var url = "/ajax_search?q=";
        //var doc = showtime.httpReq(service.baseURL + "/search/"+ fromPage +"/0/000/0/" + query.replace(/\s/g, '\+')).toString();
        var doc = showtime.httpReq(service.baseURL + url + encodeURIComponent(query), {headers: {'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/604.4.7 (KHTML, like Gecko) Version/11.0.2 Safari/604.4.7'}}).toString();
	    page.loading = false;
            search(page, doc);
	    if (!doc.match(/downgif/)) return tryToSearch = false;
            fromPage++;
	    return true;
	};
	loader();
	page.asyncPaginator = loader;
      });
})(this);